## cairo-dock-plug-ins 3.6.0

=== CMakeLists.txt ===
########### requirements ###############

cmake_minimum_required (VERSION 3.16.0)

project ("cairo-dock-plugins" C)

find_package (PkgConfig)
include (CheckLibraryExists)
include (CheckIncludeFiles)
include (CheckFunctionExists)
include (CheckSymbolExists)
include (GNUInstallDirs)

########### project ###############

set (VERSION "3.6.0")
# can be different from VERSION, e.g. if a new version of plugins does not depend on things added to core
set (CORE_REQUIRED_VERSION "3.6.0")

add_definitions (-std=gnu99 -Wall -Werror-implicit-function-declaration) # -Wextra -Wwrite-strings -Wuninitialized -Werror-implicit-function-declaration -Wstrict-prototypes -Wreturn-type -Wparentheses -Warray-bounds)
if (NOT DEFINED CMAKE_BUILD_TYPE)
	add_definitions (-O3)
endif()
add_definitions (-DGL_GLEXT_PROTOTYPES="1")

############ adjust prefix ##############
# (this is to make things work if the user is using
# CMAKE_INSTALL_PREFIX for both core and plugins to set
# and installation path)
if(NOT DEFINED CMAKE_PREFIX_PATH)
	set (CMAKE_PREFIX_PATH "${CMAKE_INSTALL_PREFIX}")
endif()

############ sources tarball #############

set (CPACK_SOURCE_GENERATOR "TGZ")
set (CPACK_SOURCE_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${VERSION}")
set (CPACK_SOURCE_IGNORE_FILES
	"/build/;/.bzr/;/.bzrignore$;/.git/;/.gitignore$;/misc/;~$;${CPACK_SOURCE_IGNORE_FILES}")
include (CPack)

add_custom_target(dist
	COMMAND ${CMAKE_MAKE_PROGRAM} package_source)
add_custom_target(dist-bzr
	COMMAND bzr export ${CMAKE_PROJECT_NAME}-${VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

############ uninstall #############

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake IMMEDIATE @ONLY)
add_custom_target (uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

########### global variables ###############

if( WIN32 )
	message(FATAL_ERROR "Cairo-Dock requires an air-conditioned room. Please close Windows!")
endif( WIN32 )

set (PACKAGE ${CMAKE_PROJECT_NAME})

if ("${PACKAGEMENT}" STREQUAL "") ## do not check if we're using the same version when packaging the application (e.g. if we just want to generate a tarball of a previous version)
	# we need GLDI which contains most global var: check it now to avoid many errors with regex
	pkg_check_modules (GLDI REQUIRED gldi>=${CORE_REQUIRED_VERSION})
endif ()

set (dock_version ${VERSION}) # should be the same except if PACKAGEMENT is set

pkg_get_variable(pluginsdir         gldi pluginsdir)
pkg_get_variable(pluginsdatarootdir gldi pluginsdatarootdir)
pkg_get_variable(prefix             gldi plugins_prefix)
pkg_get_variable(localedir          gldi plugins_locale)
pkg_get_variable(gettext_domain     gldi plugins_gettext)
pkg_get_variable(gtkversion         gldi gtkversion)
pkg_get_variable(pkgdatadir         gldi pkgdatadir)

# check that installation dir matches with the core
if (NOT "${CMAKE_INSTALL_PREFIX}" STREQUAL "${prefix}")
	if (NOT CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		message (STATUS "It seems that the current CMAKE_INSTALL_{PREFIX,LIBDIR,DATAROOTDIR} flags are not set to what is expected by the core.")
		message (STATUS " It will be replaced by this value: ${prefix}")
		message (WARNING "Plug-ins should be installed in the directory defined when setting up the core, that is to say in ${pluginsdir}")
	endif()
	set (CMAKE_INSTALL_PREFIX "${prefix}")
endif()

# set internationalisation
set (GETTEXT_PLUGINS "${gettext_domain}")
# set base data directories
set (pluginsdatadir "${pluginsdatarootdir}/plug-ins")
set (gaugesdir "${pluginsdatarootdir}/gauges")
# needed for Turbo-night-fuel which is provided by core
set (gaugesdir_core "${pkgdatadir}/gauges")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules/")  # additionnal FindPackage files

set (MODULES_MISSING "")
set (MODULES_INTEGRATION_MISSING "")
set (PROGRAMS_MISSING "")


###########     Misc     ###############
macro (enable_if_not_defined MODULE1)
	if (NOT DEFINED ${MODULE1}) # true if not defined
		set (${MODULE1} TRUE)
	endif ()
endmacro (enable_if_not_defined)


##########     Config    ###############

enable_if_not_defined (force-icon-in-menus)
if (force-icon-in-menus)  # we believe that not showing icons in the menus by default is a terrible idea; unfortunately, it's not easily undoable for an end-user; so until this is fixed by a big player (Gnome, Ubuntu or other), we'll force the display, unless "-Dforce-icon-in-menus=yes" is provided in the cmake command.
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=1)
else()
	add_definitions (-DCAIRO_DOCK_FORCE_ICON_IN_MENUS=0)
endif()


########### dependancies ###############

message ("")
message (STATUS "=====================")
message (STATUS "Check dependencies...")
message (STATUS "=====================")
message ("")

pkg_check_modules ("PACKAGE" REQUIRED "gldi")  # we check first the common libs that most plug-ins would need: basically, all the libs used by the core.
STRING (REGEX REPLACE "gldi;" "" PACKAGE_LIBRARIES "${PACKAGE_LIBRARIES}")  # but we don't want to link to gldi, since we are dl-opened by it.

# add_definitions (-DGTK_DISABLE_DEPRECATED="1")

#############    GLIB    #################
pkg_check_modules (GLIB glib-2.0>=2.36) # same version as used in core

############# SHARED-FILES #################
set (shared_filesdatadir "${pluginsdatadir}/shared-files")
add_subdirectory (shared-files)



################################################################################
#          STATIC LIBS AND DEPENDENCES USED BY MORE THAN ONE PLUG-IN           #
################################################################################



############# STATIC LIBRARIES ################
message (STATUS "> Static Libraries:")

############# GVFS-INTEGRATION ################
message (STATUS "> GVFS-Integration:")
pkg_check_modules ("LIBGIO" "gio-2.0") ## GIO is used by a few applets: do not offer the possibility to not disable it
add_subdirectory (gvfs-integration)

############# INDICATOR-APPLET #################
message (STATUS "> Indicator-Applet:")
enable_if_not_defined (enable-dbusmenu-support)
if (enable-dbusmenu-support)
	# Note: the names of dbusmenu-glib, dbusmenu-gtk and indicator have changed...
	## DBusMenu Glib
	set (DBUSMENU_MODULE dbusmenu-glib-0.4)
	pkg_check_modules (DBUSMENU ${DBUSMENU_MODULE})
	if (NOT DBUSMENU_FOUND)
		set (DBUSMENU_MODULE dbusmenu-glib)
		pkg_check_modules (DBUSMENU ${DBUSMENU_MODULE})
		set (INDICATOR_APPLICATIONADDED_HAS_HINT 0) # doesn't have 'hint' with old version
	else ()
		set (INDICATOR_APPLICATIONADDED_HAS_HINT 1) # now the ApplicationAdded signal (Status-Notifier) has a new parameter (hint) => https://code.launchpad.net/~ted/indicator-application/name-hints/+merge/67213
	endif()

	## DBusMenu Gtk
	set (DBUSMENU_GTK_MODULE dbusmenu-gtk3-0.4)
	pkg_check_modules (DBUSMENU_GTK ${DBUSMENU_GTK_MODULE})
	if (NOT DBUSMENU_GTK_FOUND)
		set (DBUSMENU_GTK_MODULE dbusmenu-gtk3)
		pkg_check_modules (DBUSMENU_GTK ${DBUSMENU_GTK_MODULE})
	endif()
endif()

## Indicator
enable_if_not_defined (enable-indicator-support)
if (enable-indicator-support)
	set (INDICATOR_APPLET_MODULE ayatana-indicator3-0.4)
	pkg_check_modules (INDICATOR_APPLET ${INDICATOR_APPLET_MODULE})
endif()

## libido
enable_if_not_defined (enable-libido-support)
if (enable-libido-support)
	set (IDO_MODULE libayatana-ido3-0.4)
	pkg_check_modules (IDO ${IDO_MODULE})
endif()

## Extract versions of DBusMenu
if (DBUSMENU_FOUND AND DBUSMENU_GTK_FOUND)
	STRING (REGEX REPLACE "\\..*" "" DBUSMENU_MAJOR "${DBUSMENU_VERSION}")
	STRING (REGEX REPLACE "[0-9]*\\.([^ ]+)" "\\1" DBUSMENU_MINOR "${DBUSMENU_VERSION}")  # 0.1.7 => 1.7
	STRING (REGEX REPLACE "\\.[0-9]*" "" DBUSMENU_MINOR "${DBUSMENU_MINOR}")
	STRING (REGEX REPLACE ".*\\." "" DBUSMENU_NANO "${DBUSMENU_VERSION}")
	STRING (REGEX REPLACE "-.*" "" DBUSMENU_NANO "${DBUSMENU_NANO}")

	STRING (REGEX REPLACE "\\..*" "" DBUSMENU_GTK_MAJOR "${DBUSMENU_GTK_VERSION}")
	STRING (REGEX REPLACE "[0-9]*\\.([^ ]+)" "\\1" DBUSMENU_GTK_MINOR "${DBUSMENU_GTK_VERSION}")  # 0.1.7 => 1.7
	STRING (REGEX REPLACE "\\.[0-9]*" "" DBUSMENU_GTK_MINOR "${DBUSMENU_GTK_MINOR}")
	STRING (REGEX REPLACE ".*\\." "" DBUSMENU_GTK_NANO "${DBUSMENU_GTK_VERSION}")
	STRING (REGEX REPLACE "-.*" "" DBUSMENU_GTK_NANO "${DBUSMENU_GTK_NANO}")
	
	if (${DBUSMENU_GTK_MAJOR} GREATER 0 OR ${DBUSMENU_GTK_MINOR} GREATER 5
	    OR (${DBUSMENU_GTK_MINOR} EQUAL 5 AND ${DBUSMENU_GTK_NANO} GREATER 89))
		set (INDICATOR_APPLICATIONADDED_HAS_TITLE 1) # Status-Notifier: new parameter "Title" in the "added" signal since Precise
	else()
		set (INDICATOR_APPLICATIONADDED_HAS_TITLE 0)
	endif()
endif()

## Extract version of indicator
if (INDICATOR_APPLET_FOUND)
	STRING (REGEX REPLACE "\\..*" "" INDICATOR_MAJOR "${INDICATOR_APPLET_VERSION}")
	STRING (REGEX REPLACE "[0-9]*\\.([^ ]+)" "\\1" INDICATOR_MINOR "${INDICATOR_APPLET_VERSION}")  # 0.1.7 => 1.7
	STRING (REGEX REPLACE "\\.[0-9]*" "" INDICATOR_MINOR "${INDICATOR_MINOR}")
	STRING (REGEX REPLACE ".*\\." "" INDICATOR_NANO "${INDICATOR_APPLET_VERSION}")
	STRING (REGEX REPLACE "-.*" "" INDICATOR_NANO "${INDICATOR_NANO}")
	
	if (${INDICATOR_MAJOR} GREATER 0 OR ${INDICATOR_MINOR} GREATER 4
	    OR (${INDICATOR_MINOR} EQUAL 4 AND ${INDICATOR_NANO} GREATER 89))
		set (SOUND_SERVICE_VERSION 1) # Sound-Menu: new DBus path
		set (INDICATOR_MESSAGES_HAS_LOZENGE 1)   # Messaging Menu has 'right-is-lozenge'
	else() # older than Precise.
		set (SOUND_SERVICE_VERSION 0)
		set (INDICATOR_MESSAGES_HAS_LOZENGE 0)
	endif()

	execute_process(
		COMMAND pkg-config --variable=iconsdir ayatana-indicator3-0.4
		OUTPUT_VARIABLE INDICATORICONSDIR)
	execute_process(
		COMMAND pkg-config --variable=indicatordir ayatana-indicator3-0.4
		OUTPUT_VARIABLE INDICATORDIR)
	STRING (REGEX REPLACE "\n" "" INDICATORDIR ${INDICATORDIR})
	set (with_indicator3 yes)
	message (STATUS "  Indicators: with Indicator3 support")

	STRING (REGEX REPLACE "\n" "" INDICATORICONSDIR "${INDICATORICONSDIR}")  # la commande rajoute un retour chariot ...
	if (with_indicator3)
		add_subdirectory (Indicator-applet3)
	endif()
	## DBusMenu is needed for Indicator-applet
	if (DBUSMENU_FOUND AND DBUSMENU_GTK_FOUND)
		add_subdirectory (Indicator-applet)
		set (with_indicator "yes")
	endif()
endif()

if (NOT DBUSMENU_FOUND OR NOT DBUSMENU_GTK_FOUND OR NOT INDICATOR_APPLET_FOUND)
	message (WARNING "These modules are required to compile Indicators applet (Messaging-Menu, Sound-Control, Status-Notifier and Global-Menu): ${INDICATOR_APPLET_MODULE}(-0.4), ${IDO_MODULE}, ${DBUSMENU_MODULE}(-0.4), ${DBUSMENU_GTK_MODULE}(-0.4)")
	set (MODULES_MISSING "${MODULES_MISSING} ${INDICATOR_APPLET_MODULE}(-0.4) (${IDO_MODULE}) ${DBUSMENU_MODULE}(-0.4) ${DBUSMENU_GTK_MODULE}(-0.4)")
endif()

############# UPOWER #####################
message (STATUS "> UPower:")
enable_if_not_defined (enable-upower-support)
if (enable-upower-support)
	pkg_check_modules (UPOWER upower-glib)  # useful for Powermanager too.
endif()
if (UPOWER_FOUND)
	set (with_upower_support yes)
	STRING (REGEX REPLACE "\\..*" "" UPOWER_MAJOR "${UPOWER_VERSION}") # 2.28.3 => 2
	STRING (REGEX REPLACE "[0-9]*\\.([^ ]+)" "\\1" UPOWER_MINOR "${UPOWER_VERSION}")  # 2.28.3 => 2.28
	STRING (REGEX REPLACE "\\.[0-9]*" "" UPOWER_MINOR "${UPOWER_MINOR}") # 2.28 => 28
	if (${UPOWER_MAJOR} GREATER 0 OR ${UPOWER_MINOR} GREATER 89)
		message (STATUS "   Your version of UPower no longer supports suspend/hibernate features")
		set (with_upower_support "yes (0.99+)")
	else()
		set (UPOWER_SUPPORTS_SUSPEND_HIBERNATE 1)
	endif()
else()
	set (with_upower_support no)
	message (STATUS "Could not find upower-glib; Logout and PowerManager plugin won't be built with UPower support.")
	message (WARNING "This module is required to compile LogOut and PowerManager applet with UPower support: upower-glib")
	set (MODULES_MISSING "${MODULES_MISSING} upower-glib")
endif()

############# DISTRIBUTION #################
message (STATUS "> Distribution:")

=== Dbus/CMakeLists.txt ===

add_subdirectory(src)
add_subdirectory(data)
add_subdirectory(interfaces)

=== icon-effect/CMakeLists.txt ===
add_subdirectory(src)
add_subdirectory(data)


########### install files ###############




#original Makefile.am contents follow:

##dnl Process this file with automake to produce Makefile.in
#
#SUBDIRS = . src data

=== po/CMakeLists.txt ===

find_program (MSGFMT_EXECUTABLE msgfmt)

#on cree une nouvelle cible i18n liee a la cible "all".
add_custom_target (i18n ALL COMMENT “Building i18n messages.”)

# on liste tous les .po
file (GLOB PO_FILES *.po)

# on parcours cette liste.
foreach (PO_INPUT ${PO_FILES})
	get_filename_component (PO_INPUT_BASE ${PO_INPUT} NAME_WE)  # NAME Without Extension.
	if (NOT "${PO_INPUT_BASE}" STREQUAL "en_GB") # en_GB has been created only for LaunchPad translation tool
		set (MO_OUTPUT ${PO_INPUT_BASE}.gmo)  # le nom du fichier en sortie.
		message (STATUS "  Building ${MO_OUTPUT}...")
		add_custom_command (TARGET i18n POST_BUILD COMMAND ${MSGFMT_EXECUTABLE} -o  ${CMAKE_CURRENT_BINARY_DIR}/${MO_OUTPUT} ${PO_INPUT})  # appel a msgfmt.
		install (FILES  ${CMAKE_CURRENT_BINARY_DIR}/${MO_OUTPUT} DESTINATION ${localedir}/${PO_INPUT_BASE}/LC_MESSAGES RENAME ${GETTEXT_PLUGINS}.mo)  # installation du fichier dans le bon repertoire.
	endif ()
endforeach ()

=== Animated-icons/data/CMakeLists.txt ===

########### install files ###############

install(FILES  ${CMAKE_CURRENT_BINARY_DIR}/Animated-icons.conf
	preview.jpg
	icon.svg
	texture-chrome.png
	icon-rotation.png
	spot.png
	halo.png
	ray.png
	icon-wave.png
	icon-busy.png
	busy.svg
	DESTINATION ${animated_iconsdatadir})

=== Dbus/data/CMakeLists.txt ===

########### install files ###############

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Dbus.conf
	icon.svg
	DESTINATION ${dbusdatadir})

# Unity Launcher API ## need SetMenu => DBusMenu
if (${DBUSMENU_GTK_FOUND})
	install(FILES cairo-dock-launcher-API-daemon.py
		DESTINATION ${pluginsdir}
		RENAME cairo-dock-launcher-API-daemon
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

=== Dbus/src/CMakeLists.txt ===

########### sources ###############

SET (cd-Dbus_LIB_SRCS
	applet-init.c 				applet-init.h
	applet-config.c 			applet-config.h
	applet-dbus.c 				applet-dbus.h
	interface-main-methods.c 	interface-main-methods.h
	interface-main-query.c 		interface-main-query.h
	interface-applet-object.c 	interface-applet-object.h
	interface-applet-methods.c 	interface-applet-methods.h
	interface-applet-signals.c 	interface-applet-signals.h
	dbus-applet-spec.h
	dbus-sub-applet-spec.h
	dbus-main-spec.h
	applet-struct.h
)

add_library (${PACKAGE_DBUS} SHARED ${cd-Dbus_LIB_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${dbusdatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="none")
add_definitions (-DMY_APPLET_CONF_FILE="Dbus.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Dbus")
add_definitions (-DMY_APPLET_VERSION="${VERSION_DBUS}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_DBUS}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.svg")
add_definitions (-DCD_PLUGINS_DIR="${pluginsdir}")

IF (${CMAKE_SYSTEM_NAME} MATCHES "^FreeBSD")
	set(kvm "kvm")
endif()

if (DBUSMENU_FOUND AND DBUSMENU_GTK_FOUND)
	message (STATUS " * With DBusMenu support")
	add_definitions (-DDBUSMENU_GTK_FOUND=1)

	include_directories (
		${DBUSMENU_INCLUDE_DIRS}
		${DBUSMENU_GTK_INCLUDE_DIRS}
		${PACKAGE_INCLUDE_DIRS})

	link_directories (
		${DBUSMENU_LIBRARY_DIRS}
		${DBUSMENU_GTK_LIBRARY_DIRS}
		${PACKAGE_LIBRARY_DIRS})

	target_link_libraries (${PACKAGE_DBUS}
		${DBUSMENU_LIBRARIES}
		${DBUSMENU_GTK_LIBRARIES}
		${PACKAGE_LIBRARIES}
		${kvm})
else()
	include_directories (
		${PACKAGE_INCLUDE_DIRS})

	link_directories (
		${PACKAGE_LIBRARY_DIRS})

	target_link_libraries (${PACKAGE_DBUS}
		${PACKAGE_LIBRARIES}
		${kvm})
endif()

########### install files ###############

install (TARGETS ${PACKAGE_DBUS} DESTINATION ${pluginsdir})

=== Folders/src/CMakeLists.txt ===

########### sources ###############

SET(MODULE_SRCS
	applet-struct.h
	applet-init.c 				applet-init.h
	applet-config.c 			applet-config.h
	applet-load-icons.c 		applet-load-icons.h
	applet-notifications.c 		applet-notifications.h
)

add_library(${PACKAGE_FOLDERS} SHARED ${MODULE_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${foldersdatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="preview.jpg")
add_definitions (-DMY_APPLET_CONF_FILE="Folders.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Folders")
add_definitions (-DMY_APPLET_VERSION="${VERSION_FOLDERS}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_FOLDERS}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.png")
add_definitions (-DCD_APPLET_MULTI_INSTANCE="1")
### uncomment the following line to allow extended OpenGL drawing.
#add_definitions (-DGL_GLEXT_PROTOTYPES="1")

include_directories (
	${PACKAGE_INCLUDE_DIRS})

link_directories (
	${PACKAGE_LIBRARY_DIRS})

target_link_libraries (${PACKAGE_FOLDERS}
	${PACKAGE_LIBRARIES})

########### install files ###############

install(TARGETS ${PACKAGE_FOLDERS} DESTINATION ${pluginsdir})

=== Messaging-Menu/data/CMakeLists.txt ===

########### install files ###############

install (FILES ${CMAKE_CURRENT_BINARY_DIR}/Messaging-Menu.conf
	preview.jpg
	icon.svg
	indicator-messages.svg
	indicator-messages-new.svg
	DESTINATION ${messaging_menudatadir})

=== RSSreader/data/CMakeLists.txt ===

########### install files ###############

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/RSSreader.conf
	preview.jpg
	icon.svg
	DESTINATION ${rss_readerdatadir})

=== Remote-Control/src/CMakeLists.txt ===

########### sources ###############

SET(MODULE_SRCS
	applet-struct.h
	applet-init.c 			applet-init.h
	applet-config.c 			applet-config.h
	applet-session.c 			applet-session.h
	applet-icon-finder.c 		applet-icon-finder.h
	applet-notifications.c 		applet-notifications.h
)

add_library(${PACKAGE_REMOTE_CONTROL} SHARED ${MODULE_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${remote_controldatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="preview.jpg")
add_definitions (-DMY_APPLET_CONF_FILE="Remote-Control.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Remote-Control")
add_definitions (-DMY_APPLET_VERSION="${VERSION_REMOTE_CONTROL}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_REMOTE_CONTROL}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.png")
### uncomment the following line to allow multi-instance applet.
#add_definitions (-DCD_APPLET_MULTI_INSTANCE="1")
### uncomment the following line to allow extended OpenGL drawing.
#add_definitions (-DGL_GLEXT_PROTOTYPES="1")

include_directories (
	${PACKAGE_INCLUDE_DIRS})

link_directories (
	${PACKAGE_LIBRARY_DIRS})

target_link_libraries (${PACKAGE_REMOTE_CONTROL}
	${PACKAGE_LIBRARIES})

########### install files ###############

install(TARGETS ${PACKAGE_REMOTE_CONTROL} DESTINATION ${pluginsdir})

=== Scooby-Do/src/CMakeLists.txt ===

########### sources ###############

SET(cd-Scooby-Do_LIB_SRCS
	applet-init.c 			applet-init.h
	applet-config.c 			applet-config.h
	applet-notifications.c 		applet-notifications.h
	applet-draw.c 			applet-draw.h
	applet-session.c 			applet-session.h
	applet-listing.c 			applet-listing.h
	applet-icon-finder.c 		applet-icon-finder.h
	applet-appli-finder.c 		applet-appli-finder.h
	applet-search.c 			applet-search.h
	applet-backend-command.c 	applet-backend-command.h
	applet-backend-files.c 		applet-backend-files.h
	applet-backend-web.c 		applet-backend-web.h
	applet-backend-firefox.c 	applet-backend-firefox.h
	applet-backend-recent.c 	applet-backend-recent.h
	applet-struct.h
)

add_library(${PACKAGE_SCOOBY_DO} SHARED ${cd-Scooby-Do_LIB_SRCS})

########### compil ###############
add_definitions (-DMY_APPLET_SHARE_DATA_DIR="${scooby_dodatadir}")
add_definitions (-DMY_APPLET_PREVIEW_FILE="preview.jpg")
add_definitions (-DMY_APPLET_CONF_FILE="Scooby-Do.conf")
add_definitions (-DMY_APPLET_USER_DATA_DIR="Scooby-Do")
add_definitions (-DMY_APPLET_VERSION="${VERSION_SCOOBY_DO}")
add_definitions (-DMY_APPLET_GETTEXT_DOMAIN="${GETTEXT_SCOOBY_DO}")
add_definitions (-DMY_APPLET_DOCK_VERSION="${dock_version}")
add_definitions (-DMY_APPLET_ICON_FILE="icon.png")
add_definitions (-DGL_GLEXT_PROTOTYPES="1")

include_directories (
	${PACKAGE_INCLUDE_DIRS})

link_directories (
	${PACKAGE_LIBRARY_DIRS})

target_link_libraries (${PACKAGE_SCOOBY_DO}
	${PACKAGE_LIBRARIES})

########### install files ###############

install(TARGETS ${PACKAGE_SCOOBY_DO} DESTINATION ${pluginsdir})


########### install files ###############




#original Makefile.am contents follow:

# #dnl Process this file with automake to produce Makefile.in
#
#lib_LTLIBRARIES = 
#	libcd-Scooby-Do.la
#
#
#libcd_Scooby_Do_la_SOURCES = 
#	applet-init.c
#	applet-init.h
#	applet-config.c
#	applet-config.h
#	applet-notifications.c
#	applet-notifications.h
#	applet-draw.c
#	applet-draw.h
#	applet-session.c
#	applet-session.h
#	applet-listing.c
#	applet-listing.h
#	applet-icon-finder.c
#	applet-icon-finder.h
#	applet-appli-finder.c
#	applet-appli-finder.h
#	applet-search.c
#	applet-search.h
#	applet-backend-command.c
#	applet-backend-command.h
#	applet-backend-files.c
#	applet-backend-files.h
#	applet-backend-web.c
#	applet-backend-web.h
#	applet-backend-firefox.c
#	applet-backend-firefox.h
#	applet-backend-recent.c
#	applet-backend-recent.h
#	applet-struct.h
#
#
#dock_version = `pkg-config --modversion cairo-dock`
#
#libcd_Scooby_Do_la_CFLAGS = 
#	-I$(top_srcdir)/src
#	$(PACKAGE_CFLAGS)
#	-DMY_APPLET_SHARE_DATA_DIR=""${scooby_dodatadir)""
#	-DMY_APPLET_PREVIEW_FILE=""preview.jpg""
#	-DMY_APPLET_CONF_FILE=""Scooby-Do.conf""
#	-DMY_APPLET_USER_DATA_DIR=""Scooby-Do""
#	-DMY_APPLET_VERSION=""${VERSION_SCOOBY_DO)""
#	-DMY_APPLET_GETTEXT_DOMAIN=""${GETTEXT_SCOOBY_DO)""
#	-DMY_APPLET_DOCK_VERSION=""${dock_version)""
#	-DMY_APPLET_ICON_FILE=""icon.png""
#	-DGL_GLEXT_PROTOTYPES=""1""
#	-std=c99
#	-Werror-implicit-function-declaration
##	-g -ggdb -W -Wall
#
#
#libcd_Scooby_Do_la_LIBADD = 
#	$(PACKAGE_LIBS) -lm
#
#
#libcd_Scooby_Do_la_LDFLAGS =
#	-avoid-version -module

=== debian/changelog ===
cairo-dock-plug-ins (3.6.0-0.1~mx25) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 18 Oct 2025 19:31:08 -0700

cairo-dock-plug-ins (3.6.0-ppa1~ubuntu25.04) plucky; urgency=medium

  * New upstream release

 -- Daniel Kondor <kondor.dani@gmail.com>  Mon, 29 Sep 2025 19:43:48 +0100

cairo-dock-plug-ins (3.5.99-1) jammy; urgency=medium

  * New release
  * Add plug-ins missing from the official repository:
    Status-Notifier, Indicator-Generic
  * Fix incorrect subdock rendering on HiDPI screens with EGL / Wayland.
  * Small improvements in rendering dialogs and menus.

 -- Daniel Kondor <kondor.dani@gmail.com>  Sat, 9 Mar 2024 23:40:00 +0100

cairo-dock-plug-ins (3.5.0) unreleased

  * Update to 3.5.0
  * Several bug fixes since the last release.
  
 -- Daniel Kondor <kondor.dani@gmail.com>  Sat, 9 Mar 2024 23:16:00 +0100

cairo-dock-plug-ins (3.4.1+git20201022.a0d3415c-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * Drop  cairo-dock-dbus-plug-in-interface-mono (Closes: #1043350)

 -- Bastian Germann <bage@debian.org>  Mon, 28 Aug 2023 13:54:37 +0200

=== debian/control ===
Source: cairo-dock-plug-ins
Section: x11
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Daniel Kondor <kondor.dani@gmail.com>
Build-Depends: cairo-dock-dev (>= 3.6.0),
               cmake(>= 3.16.0),
               debhelper-compat (= 12),
               dpkg-dev (>= 1.16.1~),
               libasound2-dev [linux-any],
               libayatana-ido3-dev,
               libayatana-indicator3-dev,
               libcairo2-dev (>= 1.8.0),
               libcurl4-gnutls-dev,
               libdbus-glib-1-dev,
               libdbusmenu-glib-dev,
               libdbusmenu-gtk3-dev,
               libetpan-dev,
               libexif-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libglvnd-dev | libgl-dev,
               libgnome-menu-3-dev,
               libgnutls28-dev,
               libgtk-3-dev (>= 3.22.0),
               libical-dev,
               libjson-c-dev,
               libpango1.0-dev,
               libpulse-dev,
               librsvg2-dev,
               libsensors-dev,
               libssl-dev,
               libupower-glib-dev,
               libvte-2.91-dev,
               libxklavier-dev,
               libxml2-dev,
               libxtst-dev,
               libxxf86vm-dev,
               libzeitgeist-2.0-dev,
               pkgconf,
               python3,
               ruby,
               ruby-dev,
               valac,
               x11proto-xf86vidmode-dev
Build-Conflicts: libwebkitgtk-3.0-dev, python-minimal
Standards-Version: 4.5.0
Homepage: https://github.com/Cairo-Dock/cairo-dock-core

Package: cairo-dock-plug-ins
Architecture: any
Depends: cairo-dock-alsamixer-plug-in [linux-any],
         cairo-dock-animated-icons-plug-in,
         cairo-dock-cairo-penguin-plug-in,
         cairo-dock-clipper-plug-in,
         cairo-dock-clock-plug-in,
         cairo-dock-dbus-plug-in,
         cairo-dock-dbus-plug-in-interface-python,
         cairo-dock-desklet-rendering-plug-in,
         cairo-dock-dialog-rendering-plug-in,
         cairo-dock-dnd2share-plug-in,
         cairo-dock-drop-indicator-plug-in,
         cairo-dock-dustbin-plug-in,
         cairo-dock-folders-plug-in,
         cairo-dock-gmenu-plug-in,
         cairo-dock-gnome-integration-plug-in,
         cairo-dock-icon-effect-plug-in,
         cairo-dock-illusion-plug-in,
         cairo-dock-impulse-plug-in,
         cairo-dock-indicator-generic-plug-in,
         cairo-dock-kde-integration-plug-in,
         cairo-dock-keyboard-indicator-plug-in,
         cairo-dock-logout-plug-in,
         cairo-dock-mail-plug-in,
         cairo-dock-messaging-menu-plug-in,
         cairo-dock-motion-blur-plug-in,
         cairo-dock-musicplayer-plug-in,
         cairo-dock-netspeed-plug-in,
         cairo-dock-powermanager-plug-in,
         cairo-dock-quick-browser-plug-in,
         cairo-dock-recent-events-plug-in,
         cairo-dock-remote-control-plug-in,
         cairo-dock-rendering-plug-in,
         cairo-dock-rssreader-plug-in,
         cairo-dock-shortcuts-plug-in,
         cairo-dock-showdesktop-plug-in,
         cairo-dock-showmouse-plug-in,
         cairo-dock-slider-plug-in,
         cairo-dock-stack-plug-in,
         cairo-dock-status-notifier-plug-in,
         cairo-dock-switcher-plug-in,
         cairo-dock-system-monitor-plug-in,
         cairo-dock-systray-plug-in,
         cairo-dock-terminal-plug-in,
         cairo-dock-tomboy-plug-in,
         cairo-dock-toons-plug-in,
         cairo-dock-weather-plug-in,
         cairo-dock-wifi-plug-in,
         cairo-dock-xfce-integration-plug-in,
         cairo-dock-xgamma-plug-in,
         ${misc:Depends}
Breaks: cairo-dock-plugins (<< 2.4.0~2-1)
Replaces: cairo-dock-plugins (<< 2.4.0~2-1)
Description: Cairo-dock - All plug-ins
 A collection of official plug-ins and applets for cairo-dock.
 .
 This is a metapackage depending on all available cairo-dock plug-ins to make
 installation easier.

Package: cairo-dock-plug-in-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: cairo-dock-core (<< 3.6.0), cairo-dock-plugin-data (<< 2.4.0~2-1)
Replaces: cairo-dock-plugin-data (<< 2.4.0~2-1)
Description: Cairo-dock - Plug-in data files
 A collection of official plug-ins and applets for cairo-dock.
 .
 This package provides plug-in data files.

Package: cairo-dock-alsamixer-plug-in
Architecture: linux-any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-alsamixer-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-alsamixer-plugin (<< 2.4.0~2-1)
Description: Alsamixer plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in lets you control the sound volume from the dock.
 This works with the Alsa sound driver.

Package: cairo-dock-animated-icons-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-animated-icons-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-animated-icons-plugin (<< 2.4.0~2-1)
Description: Animated icons plug-in Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in provides many different animations for your icons.

Package: cairo-dock-cairo-penguin-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-cairo-penguin-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-cairo-penguin-plugin (<< 2.4.0~2-1)
Description: Cairo-Penguin plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in adds a lively Penguin in your dock.
 Tux images are taken from Pingus, some other characters are available
 or can be added easily.

Package: cairo-dock-clipper-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-clipper-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-clipper-plugin (<< 2.4.0~2-1)
Description: Clipper plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in keeps a trace of the clipboard and mouse selection,
 so that you can recall them quickly. It's a clone of the well-know Klipper.
 This supports clipboard and mouse selection, predefined actions, and
 persistent items.

Package: cairo-dock-clock-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-clock-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-clock-plugin (<< 2.4.0~2-1)
Description: Clock plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in displays time and date in your dock.
 Two views are available : numeric and analogic, based on Cairo-Clock.
 This is compatible with the Cairo-Clock's themes, and you can detach itself to
 be a perfect clone of Cairo-Clock.
 And this supports alarms, and a basic calendar, and allows you to set time
 and date.

Package: cairo-dock-dbus-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-dbus-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-dbus-plugin (<< 2.4.0~2-1)
Suggests: cairo-dock-dbus-plug-in-interface-python (>= ${source:Version}),
          cairo-dock-dbus-plug-in-interface-ruby (>= ${source:Version}),
          cairo-dock-dbus-plug-in-interface-vala (>= ${source:Version})
Description: Dbus plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock
 .
 This plug-in lets external applications interact on the dock.
 The communication between both sides is based on Dbus.

Package: cairo-dock-dbus-plug-in-interface-python
Architecture: all
Depends: cairo-dock-plug-ins (>= ${source:Version}), python3, ${misc:Depends}
Description: library of D-Bus interface for Python of Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This package provides library of Cairo-Dock D-Bus interface for Python.

Package: cairo-dock-dbus-plug-in-interface-ruby
Architecture: all
Depends: cairo-dock-plug-ins (>= ${source:Version}),
         ruby,
         ruby-dbus,
         ruby-parseconfig,
         ${misc:Depends}
Description: library of D-Bus interface for ruby of Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This package provides library of Cairo-Dock D-Bus interface for ruby.

Package: cairo-dock-dbus-plug-in-interface-vala
Architecture: any
Depends: cairo-dock-plug-ins (>= ${source:Version}),
         valac,
         ${misc:Depends},
         ${shlibs:Depends}
Description: library of D-Bus interface for vala of Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This package provides library of Cairo-Dock D-Bus interface for vala.

Package: cairo-dock-desklet-rendering-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-desklet-rendering-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-desklet-rendering-plugin (<< 2.4.0~2-1)
Description: Desklet rendering plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in renders your desktop.

Package: cairo-dock-dialog-rendering-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-dialog-rendering-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-dialog-rendering-plugin (<< 2.4.0~2-1)
Description: Dialog rendering plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in provides some dialog decorators for dialog bubbles.

Package: cairo-dock-drop-indicator-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-drop-indicator-plugin  (<< 2.4.0~2-1)
Replaces: cairo-dock-drop-indicator-plugin (<< 2.4.0~2-1)
Description: Drop indicator plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in displays an animated indicator when you drop something
 in the dock.

Package: cairo-dock-dustbin-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-dustbin-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-dustbin-plugin (<< 2.4.0~2-1)
Description: Dustbin plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in manages the dustbin.
 Users can delete files and unmount disks by drag and dropping them on
 the icon.
 This can warn users if they use too much space.

Package: cairo-dock-icon-effect-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-icon-effect-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-icon-effect-plugin (<< 2.4.0~2-1)
Description: Icon effect plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in adds many special effects to your icons.

Package: cairo-dock-illusion-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Breaks: cairo-dock-illusion-plugin (<< 2.4.0~2-1)
Replaces: cairo-dock-illusion-plugin (<< 2.4.0~2-1)
Description: Illusion plug-in for Cairo-dock
 A collection of official plug-ins and applets for cairo-dock.
 .
 This plug-in provides animations for appearance and disappearance of icons.

Package: cairo-dock-logout-plug-in
Architecture: any
Depends: cairo-dock-plug-in-data (= ${source:Version}),
         ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
export VALAFLAGS:=$(foreach w,$(CPPFLAGS) $(CFLAGS) $(LDFLAGS),-X $(w))

%:
	dh $@  

# No dbgsym packages:
override_dh_strip:
	@echo "NO--THANKS ANYWAY--but not building dbgsym packages for MX Linux"
	dh_strip --no-automatic-dbgsym

=== debian/watch ===
version=4
opts="searchmode=plain, \
  pgpmode=none, \
  dversionmangle=auto" \
https://api.github.com/repos/Cairo-Dock/cairo-dock-plug-ins/releases \
https://api.github.com/repos/Cairo-Dock/cairo-dock-plug-ins/tarball/@ANY_VERSION@ \
debian
